<template>
  <div class="toolbar-container d-flex flex-grow-0 flex-row">
    <div class="btn-group">
      <icon-button
        :active="currentPanel === 'layer-panel'"
        icon="layer-group"
        @click="clicked('layer-panel')">
      </icon-button>
      <icon-button
        :active="currentPanel === 'locations-panel'"
        icon="map-marker"
        @click="clicked('locations-panel')">
      </icon-button>
      <template v-if="workspaceCount === 1">
        <icon-button
          icon="clone"
          @click="createWorkspace()">
        </icon-button>
      </template>
      <template v-else>
        <icon-button
          icon="times"
          @click="removeCurrentWorkspace()">
        </icon-button>
      </template>
      <icon-button
        icon="backward"
        @click="decrementStep">
      </icon-button>
      <icon-button
        v-bind:text="currentTime | unixToFormat('YYYY-MM-DD HH:mm')"
        @click="clicked('reference-time-panel')">
      </icon-button>
      <icon-button
        icon="forward"
        @click="incrementStep">
      </icon-button>
    </div>
  </div>
</template>

<script>
import moment from 'moment'
import MomentMixin from '@/core/mixins/moment'
import { CHANGE_WORKSPACE_STEP, SET_WORKSPACE_CURRENT_PANEL } from '@/store'
import { IconButton } from '@/core/components'


export default {
  name: 'toolbar',

  mixins: [
    MomentMixin,
  ],

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },
    referenceTime: {
      get() {
        return this.$store.state.workspaces[this.workspace].time.referenceTime
      }
    },

    currentHour: {
      get() {
        return this.$store.state.workspaces[this.workspace].time.step
      }
    },

    currentTime: {
      get() {
        return moment.unix(this.referenceTime).add(this.currentHour, 'hour').unix()
      }
    },

    currentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspace)
      }
    },

    workspaceCount: {
      get() {
        return this.$store.getters.workspaceCount
      },
    },
  },

  methods: {
    // Change the active panel when the buttons on the toolbar are clicked
    clicked(action) {
      if(this.currentPanel === action) {
        this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
          workspaceId: this.workspace,
          panel: null,
        })
      } else {
        this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
          workspaceId: this.workspace,
          panel: action,
        })
      }
    },

    decrementStep() {
      this.$store.commit(CHANGE_WORKSPACE_STEP, { workspace: this.workspace, step: this.currentHour - 1 })
    },

    incrementStep() {
      this.$store.commit(CHANGE_WORKSPACE_STEP, { workspace: this.workspace, step: this.currentHour + 1 })
    },

    createWorkspace() {
      //this.$store.commit(ADD_WORKSPACE, { id: createUniqueId() })
    },

    removeCurrentWorkspace() {
      //this.$store.commit(REMOVE_WORKSPACE, { id: this.workspace })
    },
  },

  components: {
    IconButton,
  },
}
</script>

<style scoped>
.toolbar-container .btn-group button.btn {
  border-radius: 0 !important;
}
</style>
